package com.vendor.burn.packagers.nand;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.cmdline.adapter.NandImg;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.packagers.nand.FlashOption;
import com.vendor.burn.packagers.nand.ip.NandIPCommon;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class NandImageDialog extends Dialog {
  protected Shell shell;
  
  private Text textOobSize;
  
  private Combo comboBlockSize;
  
  private Button buttonRandom;
  
  private Combo comboNandType;
  
  private FlashOption[] options;
  
  private FlashOption selectedFlashOption;
  
  private int blockSize;
  
  private boolean isSelectRandom;
  
  private NandIPCommon nandIp;
  
  public NandImageDialog(Shell parent, int style, NandIPCommon nandIp, IBurner burner) {
    super(parent, style);
    this.options = nandIp.getAvailableOptions(burner);
    this.nandIp = nandIp;
    setText(Messages.NandImageDialog_Title);
    createContents();
  }
  
  public FlashOption getSelectedFlashOption() {
    return this.selectedFlashOption;
  }
  
  public int getBlockSize() {
    return this.blockSize;
  }
  
  public Object open() {
    for (int i = 0; i < this.options.length; i++)
      this.comboNandType.add(this.options[i].toString()); 
    Monitor primary = Display.getCurrent().getPrimaryMonitor();
    Rectangle bounds = primary.getBounds();
    Rectangle rect = this.shell.getBounds();
    int x = bounds.x + (bounds.width - rect.width) / 2;
    int y = bounds.y + (bounds.height - rect.height) / 2;
    this.shell.setLocation(x, y);
    this.shell.open();
    this.shell.layout();
    Display display = getParent().getDisplay();
    while (!this.shell.isDisposed()) {
      if (!display.readAndDispatch())
        display.sleep(); 
    } 
    return null;
  }
  
  private void createContents() {
    this.shell = new Shell(getParent());
    this.shell.setSize(320, 240);
    this.shell.setText(getText());
    GridLayout gl_shell = new GridLayout(2, false);
    gl_shell.verticalSpacing = 8;
    gl_shell.horizontalSpacing = 8;
    gl_shell.marginHeight = 8;
    gl_shell.marginWidth = 8;
    this.shell.setLayout((Layout)gl_shell);
    Label lblNandType = new Label((Composite)this.shell, 0);
    lblNandType.setLayoutData(new GridData(131072, 16777216, false, false, 1, 1));
    lblNandType.setText(Messages.NandImageDialog_NandType);
    this.comboNandType = new Combo((Composite)this.shell, 8);
    this.comboNandType.setLayoutData(new GridData(4, 16777216, true, false, 1, 1));
    this.comboNandType.addSelectionListener((SelectionListener)new Object(this));
    Label lblOobSize = new Label((Composite)this.shell, 0);
    lblOobSize.setLayoutData(new GridData(131072, 16777216, false, false, 1, 1));
    lblOobSize.setText(Messages.NandImageDialog_OOBSize);
    this.textOobSize = new Text((Composite)this.shell, 2048);
    this.textOobSize.setLayoutData(new GridData(4, 16777216, true, false, 1, 1));
    Label lblRandomization = new Label((Composite)this.shell, 0);
    lblRandomization.setLayoutData(new GridData(131072, 16777216, false, false, 1, 1));
    lblRandomization.setText(Messages.NandImageDialog_Randomization);
    Button btnCheckButton = new Button((Composite)this.shell, 32);
    btnCheckButton.setEnabled(false);
    btnCheckButton.addSelectionListener((SelectionListener)new Object(this, btnCheckButton));
    btnCheckButton.setText("");
    this.buttonRandom = btnCheckButton;
    Label lblBlockSize = new Label((Composite)this.shell, 0);
    lblBlockSize.setLayoutData(new GridData(131072, 16777216, false, false, 1, 1));
    lblBlockSize.setText(Messages.NandImageDialog_BlockSize);
    this.comboBlockSize = new Combo((Composite)this.shell, 8);
    if (this.nandIp instanceof com.vendor.burn.packagers.nand.ip.NandIP600 || this.nandIp instanceof com.vendor.burn.packagers.nand.ip.NandIP620) {
      this.comboBlockSize.setEnabled(true);
    } else {
      this.comboBlockSize.setEnabled(false);
    } 
    if (this.nandIp instanceof com.vendor.burn.packagers.nand.ip.NandIP620) {
      for (int i = 0; i < (NandImg.getBlockSizeStrs620()).length; i++)
        this.comboBlockSize.add(NandImg.getBlockSizeStrs620()[i]); 
    } else {
      for (int i = 0; i < (NandImg.getBlockSizeStrs()).length; i++)
        this.comboBlockSize.add(NandImg.getBlockSizeStrs()[i]); 
    } 
    this.comboBlockSize.setLayoutData(new GridData(4, 16777216, true, false, 1, 1));
    Label lblTips = new Label((Composite)this.shell, 64);
    lblTips.setLayoutData(new GridData(4, 16777216, false, false, 2, 1));
    lblTips.setText(Messages.NandImageDialog_Tips);
    lblTips.setForeground(new Color((Device)Display.getCurrent(), 255, 0, 0));
    Composite compositeButtons = new Composite((Composite)this.shell, 0);
    GridLayout gl_compositeButtons = new GridLayout(2, false);
    gl_compositeButtons.marginWidth = 0;
    gl_compositeButtons.marginHeight = 0;
    compositeButtons.setLayout((Layout)gl_compositeButtons);
    compositeButtons.setLayoutData(new GridData(4, 4, true, true, 2, 1));
    Button btnMake = new Button(compositeButtons, 0);
    btnMake.addSelectionListener((SelectionListener)new Object(this));
    GridData gd_btnMake = new GridData(16384, 1024, false, true, 1, 1);
    gd_btnMake.widthHint = 80;
    btnMake.setLayoutData(gd_btnMake);
    btnMake.setText(Messages.NandImageDialog_Make);
    Button btnCancel = new Button(compositeButtons, 0);
    btnCancel.addSelectionListener((SelectionListener)new Object(this));
    GridData gd_btnCancel = new GridData(16384, 1024, false, true, 1, 1);
    gd_btnCancel.widthHint = 80;
    btnCancel.setLayoutData(gd_btnCancel);
    btnCancel.setText(Messages.NandImageDialog_Close);
    this.shell.pack();
  }
  
  public Combo getComboBlockSize() {
    return this.comboBlockSize;
  }
  
  public void setComboBlockSize(Combo comboBlockSize) {
    this.comboBlockSize = comboBlockSize;
  }
  
  public boolean isSelectRandom() {
    return this.isSelectRandom;
  }
  
  public void setSelectRandom(boolean isSelectRandom) {
    this.isSelectRandom = isSelectRandom;
  }
}
